//
// Created by robin on 1/8/18.
//

#ifndef QDNSAGG_QDNSQUERY_H
#define QDNSAGG_QDNSQUERY_H

#include <qplatformdefs.h>
#include <QString>

namespace QDns
{

    class QDnsQuery
    {
    public:
        QDnsQuery();

        static QDnsQuery parse(const QByteArray& packetData, quint32 pos);
        QByteArray serialize(const QByteArray& data) const;

        bool isValid() const;

        const QString& getName() const;
        void setName(const QString& name);

        quint16 getType() const;
        void setType(quint16 type);

        quint16 getClass() const;
        void setClass(quint16 aClass);

    private:
        bool m_isValid;

        QString m_name;
        quint16 m_type;
        quint16 m_class;
    };

}

#endif //QDNSAGG_QDNSQUERY_H
